#!/bin/sh 
povray /cluster/src/pov/clustp.ini +FN32 +UA +O/cluster/tmp/pov/clustp_mask.png +I/cluster/src/pov/clustp_mask.pov

###########################################################################
#
# /cluster/src/pov/00b_clustp_mask_pov.sh
# 11.01.2005 Fred Koegler
# Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
#
# Posterhintergrund mit groer Pixelzahl und hoher Antialiasing - Qualitaet
# und transparente Bildmaske aus dem PVMPOV-Logfile, die Bildausschnitte 
# der einzelnen beteiligten Rechner kennzeichnet
#
# notwendige Dateien:
# - /cluster/src/pov/clustp.ini
# - /cluster/src/pov/clustp_mask.pov
# - /cluster/tmp/pvmpov-slavelog
# - im POVRay-include - Verzeichnis: timrom.ttf
# zus. Dateien:
# - /cluster/src/pov/00a_clustp_pov.sh
# - /cluster/src/pov/clustp.pov
# - /cluster/src/pov/tux.pov 
# - /cluster/src/pov/bob.pov
# 
# Bemerkung:
# - Die von PVMPOV horizontal geviertelte Gridgroesze sollte 320x240 betragen.
# - Die Berechnung der Bildgroesze ist von der Leistungsfaehigkeit des
#   Clusters abhaengig.
#
# Parametereinstellung:
# - /cluster/src/pov/clustp_mask.pov
# - /cluster/src/pov/clustp.ini (Width, Height)
# 
# Milchmaedchenrechnung fuer Dimensionierung:
# Test =  1 x 3.2 GHz & 2560x1920 & Threshold=0.05 & Depth=4 = 26 min
# ... Schaetzung fuer 20 Rechner x [0.5,3.5] GHz = 40 GHz Cluster
# - notwendige Segmente aus GHz-KGV : mind. 20 x 2 x 3.5/0.5 = 280
# - Bildkantenlaenge in Segmenten   : int(sqrt(280)+.499) = 17
# - Bildgroesze in Segmenten        : 17x17=289 
# - Pixel Bildgroesze               : 17x320 x 17x240 = 5440x4080
# - Zeit im Cluster?                : 5.25 min ?? =
# (3.2GHz/40GHz) * ( 289*0.1min parse!? + 26min * (5440x4080)/(2560x1920) )
#
###########################################################################
