// ###########################################################################
// #
// # /cluster/src/pov/bob.pov
// # 23.12.2004 Fred Koegler
// # Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
// #
// # Achterbahnbob - Makro
// #
// # Verwendung in:
// # - /cluster/src/pov/clustp.pov
// # - /cluster/src/pov/clusta_01_.pov
// # - /cluster/src/pov/clustf_0_.pov
// # 
// # speziell verwendete POVRay Elemente:
// # - bicubic_patch                : Bob-Koerper
// # 
// ###########################################################################
#macro init_bob(uv_steps)

// lower_front
// to upper_front
#declare LF01=< 0.0, 0.0,-2.0>; #declare LF02=<+5.0, 0.0,-2.00>; #declare LF03=<+5.0, 0.0,+2.00>; #declare LF04=< 0.0, 0.0,+2.0>;
#declare LF11=< 0.0,-1.0,-2.5>; #declare LF12=<+8.5,-1.0,-2.55>; #declare LF13=<+8.5,-1.0,+2.55>; #declare LF14=< 0.0,-1.0,+2.5>;
#declare LF21=< 0.0,-2.0,-2.5>; #declare LF22=<+6.8,-2.0,-2.55>; #declare LF23=<+6.8,-2.0,+2.55>; #declare LF24=< 0.0,-2.0,+2.5>;
#declare LF31=< 0.0,-2.5, 0.0>; #declare LF32=< 0.0,-2.5, 0.0>; #declare LF33=< 0.0,-2.5, 0.0>; #declare LF34=< 0.0,-2.5, 0.0>;

// lower_back
#declare LB01=LF04; #declare LB02=<-5.0, 0.0,+2.0>; #declare LB03=<-5.0, 0.0,-2.0>; #declare LB04=LF01;
#declare LB11=LF14; #declare LB12=<-5.2,-1.0,+2.5>; #declare LB13=<-5.2,-1.0,-2.5>; #declare LB14=LF11;
#declare LB21=LF24; #declare LB22=<-5.5,-2.0,+2.6>; #declare LB23=<-5.5,-2.0,-2.6>; #declare LB24=LF21;
#declare LB31=LF34; #declare LB32=LF33; #declare LB33=LF32; #declare LB34=LF31;

// upper_front
#declare UF01=LF01*.95; #declare UF02=LF02*.95; #declare UF03=LF03*.95; #declare UF04=LF04*.95;
#declare UF11=< 0.0,+0.50,-1.7>; #declare UF12=<+1.8,+0.8,-1.2>; #declare UF13=<+1.8,+0.8,+1.2>; #declare UF14=< 0.0,+0.50,+1.7>;
#declare UF21=< 0.0,+0.25,-1.8>; #declare UF22=<+3.0,+0.5,-1.1>; #declare UF23=<+3.0,+0.5,+1.1>; #declare UF24=< 0.0,+0.25,+1.8>;
#declare UF31=LF01+<0,+.06,0>; #declare UF32=LF02+<-.03,+.01,+.03>; #declare UF33=LF03+<-.03,+.01,-.03>; #declare UF34=LF04+<0,+.06,0>;

// upper_back
#declare UB01=UF04; #declare UB02=LB02*.95; #declare UB03=LB03*.95; #declare UB04=UF01;
#declare UB11=UF14; #declare UB12=<-4.8,+0.50,+2.0>; #declare UB13=<-4.8,+0.50,-2.0>; #declare UB14=UF11;
#declare UB21=UF24; #declare UB22=<-4.9,+0.25,+2.0>; #declare UB23=<-4.9,+0.25,-2.0>; #declare UB24=UF21;
#declare UB31=LB01+<0,+.06,0>; #declare UB32=LB02+<0,+.06,0>; #declare UB33=LB03+<0,+.06,0>; #declare UB34=LB04+<0,+.06,0>;

// chrome_front
#declare CF01=LF01; #declare CF02=LF02; #declare CF03=LF03; #declare CF04=LF04;
#declare CF11=LF01+<0,.02,-.0025>; #declare CF12=LF02+<-.01,.003,+.15>; #declare CF13=LF03+<-.01,.003,-.15>; #declare CF14=LF04+<0,.02,+.0025>;
#declare CF21=LF01+<0,.04,-.0025>; #declare CF22=LF02+<-.01,.006,+.15>; #declare CF23=LF03+<-.01,.006,-.15>; #declare CF24=LF04+<0,.04,+.0025>;
#declare CF31=UF31; #declare CF32=UF32; #declare CF33=UF33; #declare CF34=UF34;

// chrome_back
#declare CB01=LB01; #declare CB02=LB02; #declare CB03=LB03; #declare CB04=LB04;
#declare CB11=CF14; #declare CB12=LB02+<+.0025,.02,-.2>; #declare CB13=LB03+<+.0025,.02,+.2>; #declare CB14=CF11;
#declare CB21=CF24; #declare CB22=LB02+<+.0025,.04,-.2>; #declare CB23=LB03+<+.0025,.04,+.2>; #declare CB24=CF21;
#declare CB31=UB31; #declare CB32=UB32; #declare CB33=UB33; #declare CB34=UB34;

// ############################################################################################################
#declare lower_front = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  LF01, LF02, LF03, LF04, LF11, LF12, LF13, LF14, LF21, LF22, LF23, LF24, LF31, LF32, LF33, LF34 }
#declare lower_back = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  LB01, LB02, LB03, LB04, LB11, LB12, LB13, LB14, LB21, LB22, LB23, LB24, LB31, LB32, LB33, LB34 }
#declare chrome_front = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  CF01, CF02, CF03, CF04, CF11, CF12, CF13, CF14, CF21, CF22, CF23, CF24, CF31, CF32, CF33, CF34 }
#declare upper_front = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  UF01, UF02, UF03, UF04, UF11, UF12, UF13, UF14, UF21, UF22, UF23, UF24, UF31, UF32, UF33, UF34 }
#declare upper_back = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  UB01, UB02, UB03, UB04, UB11, UB12, UB13, UB14, UB21, UB22, UB23, UB24, UB31, UB32, UB33, UB34 }
#declare chrome_back = bicubic_patch 
{ type 1 flatness 0.0 u_steps uv_steps v_steps uv_steps
  CB01, CB02, CB03, CB04, CB11, CB12, CB13, CB14, CB21, CB22, CB23, CB24, CB31, CB32, CB33, CB34 }

// ############################################################################################################
#declare bob = union
{
  union
  { object { lower_front } object { lower_back }
    object { lower_front scale 0.95 } object { lower_back scale 0.95 }
    texture { pigment { color rgb <.1,.2,.6> } finish  { reflection 0.001 phong 0.6 phong_size 20 } } }
  union
  { object { chrome_front } object { chrome_back }
    texture { pigment { color rgb <1,1,1> } finish  { reflection 0.033 diffuse 0.05 } } }
  union
  { object { upper_front } object { upper_back }
    texture { pigment { color rgb <.6,.2,.1> } finish  { reflection 0.001 phong 0.6 phong_size 20 } } }
}

#end
