// ###########################################################################
// #
// # /cluster/src/pov/clustf_1_.pov
// # 23.12.2004 Fred Koegler
// # Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
// #
// # 2x Tux in der Nacht, Absturz, Ausstieg aus dem Bob, Fallschirmflug,
// # Tuxbewegung bei Tageslicht, Flug durch Titelschrift (zurueck zum Anfang)
// # Verwendung als Teilfilm #3 : Abspann 
// #
// # HOWTO:
// # - /cluster/src/pov/3_clustf_1_pov.sh
// #
// # speziell verwendete POVRay Elemente:
// # - rand & superellipsoid        : Sternenhimmel
// # - cubic_spline & prism & lathe : Tux-Schnabel, Tux-Fuesze
// # - bicubic_patch                : Tux-Fluegel, Tux-Rucksack, Bob-Koerper
// # - blob                         : schwarzer Tux-Koerper
// # - superellipsoid & image_map   : Schrift
// # 
// ###########################################################################
#version 3.1;
#macro soft(cl)
  .5*(1-cos(cl*pi))
#end

// ############################################################################################################
#declare now_rot1 = <0,0,-90>;
#declare now_tran1 = <0,0,0>;
#declare para_clock = mod(clock,5)/5;
#declare para_scale1 = 1;
#declare para_scale2 = 1;
#declare tux_feet_rot = <0,0,0>;
#declare tux_feet_trans = <0,0,0>;
#declare _tux1_rot = <0,0,0>;
#declare _tux1_pos = <0,0,0>;
#declare now_rot11 = <0,0,0>;
#declare now_tran11 = <0,0,0>;
#declare _tux2_rot = <0,0,0>;
#declare _tux2_pos = <0,0,0>;
#declare now_rot12 = <0,0,0>;
#declare now_tran12 = <0,0,0>;

#declare bob_steps = 6;

#declare scene01_clock = 0.0;
#declare scene02_clock = 0.0;
#declare scene03_clock = 0.0;
#declare scene04_clock = 0.0;
#declare _himmellicht = 0.01;
#declare _licht = 1;
#declare _lichtfarbe = <1,.5,.1>;
#declare _fall  = 0;

#declare show_stars = 1;
#declare star_start = 246;
#declare star_distance = 800;

#declare show_tux  = 1;
#declare show_para = 1;

// fallschirme trudeln mit den tuxen
#switch (clock)
#range (0,10) // scene 1: tuxe steigen nacheinander aus fallschrime ffnen sich; bob verschwindet in der ferne
 #if (clock < 0.5)
  #declare _licht = clock*2;
 #end
 #declare show_bob  = 1;
 #declare scene01_clock = (clock-0)/10;
 #debug concat("### clock:",str(clock,8,3)," -> 01: ",str(scene01_clock,8,3),"\n")
 #declare tux_feet_rot = max(0,1-scene01_clock*10)*<65,0,0>;
 #declare tux_feet_trans = max(0,1-scene01_clock*10)*<0,20,-70>;
 #declare dd = 0.25;
 #declare now_tran1 = <0,-180*max(0,(scene01_clock-(.12+dd*.5)))*max(0,(scene01_clock-(.12+dd*.5))),0>;
 #declare para_scale1 = soft(min(1,max(0.001,(scene01_clock-.12)/.5)));
 #if (para_scale1 < dd)
  #declare _tux1_pos = <37,-100+para_scale1*200/dd,0>;
  #declare _tux1_rot = <0,-90,0>;
  #declare now_rot11 = <0,0,-90>;
 #else
  #declare ss = (para_scale1-dd)/(1-dd);
  #declare _tux1_pos = <37,100,0>+<243,-100,-300>*ss;
  #declare _tux1_rot = <0,-90+90*ss,0>;
  #declare now_rot11 = <0,0,-90+90*ss>;
 #end
 #declare para_scale2 = soft(min(1,max(0.001,(scene01_clock-.05)/.5)));
 #if (para_scale2 < dd)
  #declare _tux2_pos = <-100,-90+para_scale2*150/dd,0>;
  #declare _tux2_rot = <0,-90,0>;
  #declare now_rot12 = <0,0,-90>;
 #else
  #declare ss = (para_scale2-dd)/(1-dd);
  #declare _tux2_pos = <-100, 60,0>+<-220,190,100>*ss;
  #declare _tux2_rot = <0,-90+90*ss,0>;
  #declare now_rot12 = <0,0,-90+90*ss>;
 #end
 #declare xyz_camera         = <7,-10+35*scene01_clock,-10-10*scene01_clock>;
 #declare xyz_camera_look_at = <3,0+soft(scene01_clock)*10,0>;
 #declare xyz_camera_sky     = <0,1,0>;
 #break
#range (10,20) // scene 2: schwenk in hhe des unteren tux; wandel in tageslicht und zurck; tuxies bewegen sich: augen, beine, schnbel und flgel
 #declare scene01_clock = 1.0;
 #declare scene02_clock = (clock-10)/10;
 #debug concat("### clock:",str(clock,8,3)," -> 02: ",str(scene02_clock,8,3),"\n")
 #if (scene02_clock <= 0.25)
  #declare _himmellicht = max(_himmellicht,soft(scene02_clock/.25));
  #declare _fall = 0;
 #else
  #if (scene02_clock >= 0.75)
   #declare _himmellicht = max(_himmellicht,soft((1-scene02_clock)/.25));
   #declare _fall = 1;
  #else
   #declare _himmellicht = 1;
   #declare _fall = soft((scene02_clock-.25)/.5);
  #end
 #end
 #declare _lichtfarbe = <max(1,_himmellicht),max(.5,_himmellicht),max(.1,_himmellicht)>;
 #declare ss1 = soft(scene02_clock);
 #declare ss2 = soft(2*scene02_clock);
 #declare now_tran11 = <+6,-2.5,-4>;
 #declare now_tran12 = <-6,+2.5, 4>;
 #declare xyz_camera         = (1-ss1)*<7.4,22.5,0>+<-8*ss2,+6*ss1-5*_fall,-18>;
 #declare xyz_camera_look_at = (1-ss1)*<3.4,7.5,2>+<2*ss1,6*ss1,0>;
 #declare xyz_camera_sky     = <0,1,0>;
 #break
#range (20,28) // scene 3: flug mit tuxen bis kamera auf einem hellen boden landet, tuxe fliegen aber hindurch!?
 #declare show_title = 1;
 #declare scene01_clock = 1.0;
 #declare scene02_clock = 1.0;
 #declare scene03_clock = (clock-20)/8;
 #debug concat("### clock:",str(clock,8,3)," -> 03: ",str(scene03_clock,8,3),"\n")
 #declare now_tran11 = <+6,-2.5,-4>+(.75-scene03_clock)*<0,40,0>;
 #declare now_tran12 = <-6,+2.5, 4>+(.75-scene03_clock)*<0,40,0>;
 #declare ss1 = soft(min(1,scene03_clock/.75));
 #declare ss2 = soft(2*min(1,scene03_clock/.75));
 #declare xyz_camera         = <0,1,-18>+<6*ss2,(.75-ss1*.75)*40,0>;
 #declare xyz_camera_look_at = <2,6,0>+<-2*ss1,(.75-ss1)*40,0>;
 #declare xyz_camera_sky     = <0,1,0>;
 #break
#range (28,40) // scene 4: schwenk in die titelposition; fallschirme verschwinden in der ferne, licht ausblenden
 #declare show_title = 1;
 #declare scene01_clock = 1.0;
 #declare scene02_clock = 1.0;
 #declare scene03_clock = 1.0;
 #declare scene04_clock = (clock-28)/12;
 #debug concat("### clock:",str(clock,8,3)," -> 04: ",str(scene04_clock,8,3),"\n")
 #declare now_tran11 = <+6,-2.5-10,-4>-scene04_clock*<0,50,0>;
 #declare now_tran12 = <-6,+2.5-10, 4>-scene04_clock*<0,50,0>;
 #declare ss1 = soft(min(1,scene04_clock/.5));
 #declare _sin = sin(ss1*pi/2);
 #declare _cos = cos(ss1*pi/2);
 #declare _licht = soft(min(1,(1-scene04_clock)/.5));
 #declare xyz_camera         = <0,1*_cos+125*_sin,-18*_cos>;
 #declare xyz_camera_look_at = <0,-4*(1-ss1),0>;
 #declare xyz_camera_sky     = vnormalize(<0,_cos,_sin>);
// #debug concat("### _licht:",str(_licht,8,3)," ss1: ",str(ss1,8,3),"\n")
 #break
#end 

// ############################################################################################################
#declare xyz_camera_zoom = 1;
camera 
{
  location xyz_camera
  sky xyz_camera_sky
  look_at xyz_camera_look_at
  direction xyz_camera_zoom*vnormalize(xyz_camera_look_at-xyz_camera)
}

// ############################################################################################################
#ifdef (show_bob)
 #include "/cluster/src/pov/bob.pov"
 init_bob(bob_steps) 
 
 #declare ro = 0.25;
 #declare zd = 1.25;
 #declare ru = 0.50;
 #declare yd =-1.50;
 #declare rs = 0.20;
 #declare rd = sqrt(yd*yd+zd*zd);
 #declare rdro = rd+2.2*ro;
 #declare ydro = yd-yd*sqrt(rdro/rd);
 #declare zdro = zd*sqrt(rdro/rd);
  
 #declare tran0 = <5-2.25,0,0>;
 #declare tran1 = <-2.25,0,0>;
 #declare bob_rolls =
  union
  {
   difference { sphere { <0,+ydro,-zdro>, 2.0*ro scale <2.0,1,1> } cylinder { <-5*ro,0,-zd>, <+5*ro,0,-zd>, 1.20*ro } }
   difference { sphere { <0,+ydro,+zdro>, 2.0*ro scale <2.0,1,1> } cylinder { <-5*ro,0,+zd>, <+5*ro,0,+zd>, 1.20*ro } }
   sphere { <0,+ydro+ro,0>, 2*ro scale <1.0,1,1> }
   cylinder { <0,+ydro+ro,+zdro>, <0,+ydro+ro,-zdro>, 0.8*ro } 
   cylinder { <0,+ydro+ro,-zdro>, <+1.0*ro,+ydro+4.5*ro,-zdro+0.5*ro>, 0.4*ro } 
   cylinder { <0,+ydro+ro,+zdro>, <+1.0*ro,+ydro+4.5*ro,+zdro-0.5*ro>, 0.4*ro } 
   texture { pigment { color rgb <.8,.8,.05> } finish  { reflection 0.01 phong 0.1 phong_size 10 } }
  }
 union
 {
  object { bob translate <0,2.90,0> }
  object { bob_rolls translate tran1 }
  object { bob_rolls scale <-1,1,1> translate tran0 }
  cylinder 
  {
   tran0+<0,+ydro+ro,0>, tran1+<0,+ydro+ro,0>, ro
   texture { pigment { color rgb <.8,.8,.05> } finish  { reflection 0.01 phong 0.1 phong_size 10 } }
  }
  rotate now_rot1
  translate now_tran1
 }
#end

// ############################################################################################################
#ifdef (show_tux)
 #include "/cluster/src/pov/tux.pov" 
 #declare xyz_tux_eye_rechts_rotate = <-2,+3,10>;
 #declare xyz_tux_eye_links_rotate  = <-2,+3,10>;
 #declare xyz_tux_eye_rechts_lied_rotate = < 30, -15 , 0 >; 
 #declare xyz_tux_eye_links_lied_rotate  = < 30, -15 , 0 >; 
 #declare xyz_tux_head_rotate = <-10,-5,0>;
 #declare xyz_tux_foot_rechts_rotate = tux_feet_rot;
 #declare xyz_tux_foot_rechts_trans = tux_feet_trans;
 #declare xyz_tux_foot_links_rotate = tux_feet_rot;
 #declare xyz_tux_foot_links_trans = tux_feet_trans;
 #declare xyz_tux_body_trans  = <0,0,0>;
 #declare xyz_tux_rotate = _tux1_rot;
 #declare xyz_tux_trans = _tux1_pos;

#if ((scene02_clock > 0) & (scene02_clock < 1) )
 #declare tux_flug = .5*(1-cos(3*scene02_clock*2*pi));
 #declare tux_flug_x = 15;
 #declare tux_flug_y = -2;
 #declare tux_flug_z = 80;
 #declare xyz_tux_head_rotate = <-10,-5,0>+<+15,-10,0>*(.5*(1-cos(1*scene02_clock*2*pi)));
 #declare xyz_tux_eye_rechts_lied_rotate = < 30, -15 , 0 >+<-15,-70,0>*max(0,sin(3*scene02_clock*2*pi)); 
 #declare xyz_tux_eye_links_lied_rotate  = < 30, -15 , 0 >+<-15,-70,0>*max(0,sin(3*scene02_clock*2*pi)); 
 #declare tux_peek_o_rot = <0,0,0>;
 #declare tux_peek_u_rot = <-1,0,0>*7*(.5*(1-cos(3*scene02_clock*2*pi)));
 #declare xyz_tux_foot_rechts_rotate = <1,0,0>*20*.5*(1-cos(2*scene02_clock*2*pi))*.5*(1-cos(1*scene02_clock*2*pi));
 #declare xyz_tux_foot_rechts_trans = tux_feet_trans;
 #declare xyz_tux_foot_links_rotate = <1,0,0>*20*.5*(1-cos(2*scene02_clock*2*pi))*.5*(1-cos(1*scene02_clock*2*pi));
 #declare xyz_tux_foot_links_trans = tux_feet_trans;
#end
 init_tux(30)
 object { tux scale .02 translate <0,2.8,0> rotate now_rot11 translate now_tran11 }
 #ifdef (show_para)
  // Fallschirm ###################################################################
  #local fa_i = 12;
  #local pigment1 = color rgb <.90,.91,.98>;
  #local pigment2 = color rgb <1,0,0>;
  #local para_xyz = array[fa_i]
  #local fa_ppx= sqrt(250.5*250.5-60*60)*cos(atan2(tan(pi/fa_i/0.5),1));
  #local fa_ppz= fa_ppx*tan(pi/fa_i);

  #declare stoffbahn
  = difference
  {
   difference { sphere { <0,0,0>,250 } sphere { <0,0,0>,249 } scale <1,1,0.5> }
   plane { <0,0,+1>,0 rotate <0,180/fa_i,0> }
   plane { <0,0,-1>,0 rotate <0,-180/fa_i,0> }
   plane { <-1,0,0>,0 rotate <0,0,-30> translate <fa_ppx,60,0> }
   cylinder { <0,-251,0>,<0,+251,0>,250/6 }
   plane { <0,1,0>,60 }
   clipped_by { box { <-251,60-1,-251>,<+251,+251,+251> } }
  }
  
  #declare para_yrotate = -6+12*soft(2*para_clock);
  #declare fallschirm 
  = union
  {
   #local j = 1;
   #local i = 0;
   #while (i < fa_i)
    object 
    {
     stoffbahn rotate <0,i*360/fa_i+para_yrotate,0> 
     texture { pigment { color (j > 0 ? pigment1 : pigment2) } finish { diffuse .5 } }
     translate <0,250,0>
    }
    #local j = - j;
    #local i = i + 1;
   #end
  }  

  #declare fallschirm 
  = union
  {
   object { fallschirm }
   #local i = 0;
   #while (i < fa_i)
    #local para_xyz[i] = vaxis_rotate(<fa_ppx,250+60,fa_ppz>,<0,1,0>,i*360/fa_i+para_yrotate);
    #local xyz_tux = < (para_xyz[i].x > 0 ? 1 : -1) * 60+2*cos(2*pi*(i-1)/fa_i) , 0 , +2*sin(2*pi*(i-1)/fa_i) >;
    sphere { para_xyz[i] , 2 pigment { rgb <1,1,0> } }
    sphere { xyz_tux , 2 pigment { rgb <1,1,0> } }
    cylinder { para_xyz[i] , xyz_tux , .5 pigment { rgb 0.752941 } }
    #local i = i + 1;
   #end
   cylinder { <+60,0,0>,<-60,0,0>,2 pigment { rgb <0.36,0.25,0.20> } scale <1,1,.5> }
   cylinder { <+60,0,0>,<+33,-150,+33>,.5 pigment { rgb 0.752941 } }
   cylinder { <+60,0,0>,<+33,-150,-33>,.5 pigment { rgb 0.752941 } }
   cylinder { <-60,0,0>,<-33,-150,-33>,.5 pigment { rgb 0.752941 } }
   cylinder { <-60,0,0>,<-33,-150,+33>,.5 pigment { rgb 0.752941 } }
   translate < 0 , 140 , 0 > 
  }
  
  object { fallschirm scale para_scale1*<para_scale1,1,para_scale1> rotate xyz_tux_rotate translate xyz_tux_trans+<-55+55*min(1,2*para_scale1),110,-5> scale .02 translate <0,2.8,0> rotate now_rot11 translate now_tran11 }
 #end
      
 #declare xyz_tux_eye_rechts_rotate = <+5,-8,10>;
 #declare xyz_tux_eye_links_rotate  = <+5,-8,10>;
 #declare xyz_tux_eye_rechts_lied_rotate = < 40, +15 , 0 >; 
 #declare xyz_tux_eye_links_lied_rotate  = < 40, +15 , 0 >; 
 #declare xyz_tux_head_rotate = <+10,20,0>;
 #declare tux_peek_o_rot = <0,0,0>;
 #declare tux_peek_u_rot = <0,0,0>;
 #declare xyz_tux_foot_rechts_rotate = tux_feet_rot;
 #declare xyz_tux_foot_rechts_trans = tux_feet_trans;
 #declare xyz_tux_foot_links_rotate = tux_feet_rot;
 #declare xyz_tux_foot_links_trans = tux_feet_trans;
 #declare xyz_tux_body_trans  = <0,0,0>;
 #declare xyz_tux_rotate = _tux2_rot;
 #declare xyz_tux_trans = _tux2_pos;
 
#if ((scene02_clock > 0) & (scene02_clock < 1) )
 #declare tux_flug = .5*(1-cos(4*scene02_clock*2*pi));
 #declare tux_flug_x = -20;
 #declare tux_flug_y = -2;
 #declare tux_flug_z = 70;
 #declare xyz_tux_head_rotate = <+10,20,0>+<-15,-10,0>*(.5*(1-cos(2*scene02_clock*2*pi)));
 #declare xyz_tux_eye_rechts_lied_rotate = <+5,-8,10 >+<0,-80,-10>*max(0,sin(5*scene02_clock*2*pi)); 
 #declare xyz_tux_eye_links_lied_rotate  = <+5,-8,10 >+<0,-80,-10>*max(0,sin(5*scene02_clock*2*pi)); 
 #declare tux_peek_o_rot = <+1,0,0>*5*(.5*(1-cos(4*scene02_clock*2*pi)));
 #declare tux_peek_u_rot = <-1,0,0>*8*(.5*(1-cos(4*scene02_clock*2*pi)));
 #declare xyz_tux_foot_rechts_rotate = tux_feet_rot;
 #declare xyz_tux_foot_rechts_trans = tux_feet_trans;
 #declare xyz_tux_foot_links_rotate = tux_feet_rot;
 #declare xyz_tux_foot_links_trans = tux_feet_trans;
#end
 init_tux(30)
 object { tux scale .02 translate <0,2.8,0> rotate now_rot12 translate now_tran12 }
 #ifdef (show_para)
  object { fallschirm scale para_scale2*<para_scale2,1,para_scale2> rotate xyz_tux_rotate translate xyz_tux_trans+<-55+55*min(1,2*para_scale2),110,-5> scale .02 translate <0,2.8,0> rotate now_rot12 translate now_tran12 }
 #end
#end

// ############################################################################################################
#ifdef (show_stars)
 #declare camera_direction = vnormalize(xyz_camera_look_at-xyz_camera);
 #declare rrr0 = seed(star_start);
 #declare i = 0;
 #while (i < 750)
  #declare xw = 360*rand(rrr0);
  #declare yw = 360*rand(rrr0);
  #declare se1 = rand(rrr0);
  #declare se2 = rand(rrr0);
  #declare se3 = rand(rrr0);
  #declare se4 = rand(rrr0);
  #declare sc1 = rand(rrr0);
  #declare sc2 = rand(rrr0);
  #declare sw1 = rand(rrr0);
  #declare sw2 = rand(rrr0);
  #declare star_direction = vaxis_rotate(vaxis_rotate(<0,0,1>,<1,0,0>,xw),<0,1,0>,yw);
  #if (1.88<vlength(camera_direction+star_direction))
   union
   {
    superellipsoid { <12+3*se1, 12+3*se2> }
    superellipsoid { <12+3*se3, 12+3*se4> rotate <45,45,0> }
    no_shadow
    scale star_distance * <.08+.02*sc1,.08+.02*sc2,1>
    rotate <-15+30*sw1,-15+30*sw2,0>
    texture { pigment { color rgb .33 } }
    finish { metallic ambient 25 }
    translate <0,0,2*star_distance>
    rotate <xw,yw,0>
    translate xyz_camera
   }
  #end
  #declare i = i + 1;
 #end
#end

// ############################################################################################################
#ifdef (show_title)
 #macro title_grid(zfac,xxx,yyy,yyy_tran,datei)
  #local bit = .041;
  #local i_end = int(abs(zfac*xxx/yyy/2./bit)+.999);
  #local j_end = int(abs(zfac/2./bit)+.999);
  union
  {
   #local i = 0;
   #while (i <= i_end) 
    #local j = 0;
    #while (j <= j_end) 
     superellipsoid
     {
      <.5, .5>
      no_shadow 
      scale 0.85*<bit,bit,.001>
      translate bit*<-i_end+2*i,-j_end+2*j,0> 
     }
     #local j = j + 1;
    #end
    #local i = i + 1;
   #end
   texture 
   {
    pigment 
    {
     image_map { png datei map_type 0 once } 
     translate <-.5,-.5,0>
     scale zfac*<xxx/yyy,1,1>
    }
    finish { ambient 9 diffuse 0.1 reflection 0 }
   }
   translate <0,yyy_tran,0>
   rotate <90,0,0>
   scale 25
  }
 #end
 title_grid(0.18*5,546,86,.7,"/cluster/src/pov/Brandenburg_546x86_transparent.png")
 title_grid(0.18*5,493,88,-.7,"/cluster/src/pov/Clusternight_493x88_transparent.png")
#end //#ifdef (show_title)

// ############################################################################################################
global_settings
{
 adc_bailout 0.0039
 ambient_light color rgb _licht*.5*<.1,.1,.1>
 assumed_gamma 1.0
 irid_wavelength <0.25, 0.18, 0.14>
 max_trace_level 10
}

// ############################################################################################################
light_source { <0,0,0>, colour rgb _licht*_lichtfarbe/66 }
#declare sonne2 =
light_source { <0,0,0>, colour rgb _licht*_lichtfarbe*.33 }
union 
{
 object { sonne2 translate <-500,+1000,-1000> }
 object { sonne2 translate <+500,+1000,-1000> }
 object { sonne2 translate <-500,-1000,-1000> }
 object { sonne2 translate <+500,-1000,-1000> }
 object { sonne2 translate <-500,+1000,+1000> }
 object { sonne2 translate <+500,+1000,+1000> }
 object { sonne2 translate <-500,-1000,+1000> }
 object { sonne2 translate <+500,-1000,+1000> }
}

// ############################################################################################################
#declare SB = _licht*_himmellicht*<.196078,.6,.8>;
#declare MB = _licht*_himmellicht*<.184314,.184314,.309804>;
sky_sphere 
{
 pigment 
 {
  gradient y
  color_map { [.1 color rgb SB] [.4 color rgb SB] [.9 color rgb MB] [1 color rgb MB] }
  scale 2
  translate -1
 }
}
