// ###########################################################################
// #
// # /cluster/src/pov/clustp_mask.pov
// # 31.01.2005 Fred Koegler
// # Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
// #
// # Postermaske erzeugt aus dem PVMPOV-Logfile eine transparente Bildmaske
// # die Bildausschnitte der einzelnen beteiligten Rechner kennzeichnet
// # mit groer Pixelzahl und hoher Antialiasing - Qualitaet
// # (clustp.pov erzeugt den Posterhintergrund)
// #
// # HOWTO:
// # - /cluster/src/pov/00a_clustp_pov.sh
// # - /cluster/src/pov/00b_clustp_mask_pov.sh
// # 
// # speziell verwendete POVRay Elemente:
// # - text                         : Schrift
// # - fopen & read & fclose        : PVMPOV-Logfile einlesen
// ###########################################################################
#version 3.1;

#declare maxw = 9600;
#declare maxh = 7200;
#declare rod = 3/maxh;

// ############################################################################################################
#fopen clustp_log "/cluster/tmp/pvmpov-slavelog" read
#declare j = 0;
#declare i = 1;
#while (i>0)
 #declare i = 0;
 #read (clustp_log,node,v4,v0,v1,v2,v3,v5)
 #ifdef (clustp_log)
  #declare i = 1;
  #declare j = j + 1;
//  #debug concat(str(j,4,0),":",str(v2,4,0),",",str(v3,4,0),",",str(v0,4,0),",",str(v1,4,0),",",str(maxw,4,0),",",str(maxh,4,0),",",node,"\n")
 #declare xmin = max(-.5+2*rod,min(+.5-2*rod,(-.5+v2/maxw)+rod/4))*.999*4/3;
 #declare xmax = max(-.5+2*rod,min(+.5-2*rod,(-.5+v3/maxw)-rod/4))*.999*4/3;
 #declare ymin = max(-.5+rod,min(+.5-rod,-(-.5+v0/maxh+rod/4)));
 #declare ymax = max(-.5+rod,min(+.5-rod,-(-.5+v1/maxh-rod/4)));
 text 
 {
  ttf "timrom.ttf" concat(str(j,4,0),".: ",node) .01, 0
  texture 
  {
   pigment { color rgb <1,.5,.3> }
   finish { metallic ambient 0.2 diffuse 0.7 brilliance 6 reflection 0.25 phong 0.75 phong_size 60 }
//   normal { quilted 1  control0 0.5 control1 1 scale 0.45 turbulence 0.5 lambda 0.5 omega 0.707 octaves 4 }
  }
  scale 30*<1/maxw,1/maxh,1/((maxw+maxh)/2)>
  translate <xmin+4*rod,ymax+4*rod,0>
 }
 union
 {
  cylinder { <xmin,ymin,0>,<xmin,ymax,0>,rod }
  cylinder { <xmin,ymin,0>,<xmax,ymin,0>,rod }
  cylinder { <xmax,ymax,0>,<xmin,ymax,0>,rod }
  cylinder { <xmax,ymax,0>,<xmax,ymin,0>,rod }
  texture { pigment { color rgb .95 } } finish {ambient 0  diffuse 0 reflection 1}
 }
 #end
#end
#ifdef (clustp_log)
 #fclose clustp_log
#end

// ############################################################################################################
global_settings
{
  adc_bailout 0.0039
  ambient_light color rgb .5*<.1,.1,.1>
  assumed_gamma 1.0
  irid_wavelength <0.25, 0.18, 0.14>
  max_trace_level 10
}

// ############################################################################################################
background { color rgbt <0,0,0,1> }
plane 
{
 <0,0,1>, -2000
 texture { pigment { color rgb <.20,.5,.8> } } finish { metallic }
}

// ############################################################################################################
#declare sonne = 
light_source { <0,0,0>, colour rgb 1 }
union 
{
  object { sonne }
  object { sonne translate <-500,+1000,-1000> }
  object { sonne translate <+500,+1000,-1000> }
  object { sonne translate <-500,-1000,-1000> }
  object { sonne translate <+500,-1000,-1000> }
  object { sonne translate <-500,+1000,+1000> }
  object { sonne translate <+500,+1000,+1000> }
  object { sonne translate <-500,-1000,+1000> }
  object { sonne translate <+500,-1000,+1000> }
}

// ############################################################################################################
#declare xyz_camera         = <0,0,-1>;
#declare xyz_camera_look_at = <0,0,0>;
#declare xyz_camera_sky     = <0,1,0>;
#declare xyz_camera_zoom = 1;
camera {
  location xyz_camera
  sky xyz_camera_sky
  direction xyz_camera_zoom*vnormalize(xyz_camera_look_at-xyz_camera)
  look_at xyz_camera_look_at
}
