// ###########################################################################
// #
// # /cluster/src/pov/tux.pov
// # 23.12.2004 Fred Koegler
// # Zum 29.01.2005 fuer die BraLUG - "Brandenburg Clusternight"
// #
// # Tux - Makro
// #
// # Verwendung in:
// # - /cluster/src/pov/clustp.pov
// # - /cluster/src/pov/clusta_01_.pov
// # - /cluster/src/pov/clustv.pov
// # - /cluster/src/pov/clustf_0_.pov
// # - /cluster/src/pov/clustf_1_.pov
// # 
// # speziell verwendete POVRay Elemente:
// # - cubic_spline & prism & lathe : Tux-Schnabel, Tux-Fuesze
// # - bicubic_patch                : Tux-Fluegel, Tux-Rucksack
// # - blob schwarzer               : Tux-Koerper
// # 
// ###########################################################################
#declare xyz_tux_eye_rechts_rotate = <0,0,0>;
#declare xyz_tux_eye_links_rotate = <0,0,0>;
#declare xyz_tux_eye_rechts_lied_rotate = < 45 , 5 , 0 >; 
#declare xyz_tux_eye_links_lied_rotate  = < 45 , -5 , 0 >; 
#declare xyz_tux_head_rotate = <0,0,0>;
#declare tux_peek_o_rot = <0,0,0>;
#declare tux_peek_u_rot = <0,0,0>;
#declare xyz_tux_foot_rechts_rotate = <0,0,0>;
#declare xyz_tux_foot_rechts_trans = <0,0,0>;
#declare xyz_tux_foot_links_rotate = <0,0,0>;
#declare xyz_tux_foot_links_trans = <0,0,0>;
#declare xyz_tux_rotate = <0,0,0>;
#declare xyz_tux_trans = <0,0,0>;
#declare xyz_tux_body_trans  = <0,0,0>;

#declare xyz_tux_body_light  = 1;

#declare tux_flug = 0;
#declare tux_flug_x = 30;
#declare tux_flug_y = -2;
#declare tux_flug_z = 80;

#macro init_tux(num_points)

#declare curve_1 = array[num_points][2]
#declare curve_2 = array[num_points][2]
#declare curve_3 = array[num_points][2]

#declare curve_4 = array[num_points][2]
#declare curve_5 = array[num_points][2]
#declare curve_6 = array[num_points][2]
#declare curve_7 = array[num_points][2]

#local i = 0;
#while (i < num_points)
// Zehenform
  #declare curve_1[i][0] = -8+16*i/(num_points-1);
  #declare curve_1[i][1] = -6+curve_1[i][0]*curve_1[i][0]/16-1.5*cos(curve_1[i][0])-4.75-1.7;

// Fersenform
  #declare curve_2[i][0] = -curve_1[i][0];
  #declare curve_2[i][1] = -6-curve_2[i][0]*curve_2[i][0]/6+10.67;

// obere Fuform mit Unterschenkel
  #declare curve_3[i][0] = .5+(15-.5)*i/(num_points-1);
  #declare curve_3[i][1] = 10*pow(curve_3[i][0],-0.85)-0.5;

// vordere Schnabelform
  #declare curve_4[i][0] = -8+16*i/(num_points-1);
  #declare curve_4[i][1] = -14+curve_4[i][0]*curve_4[i][0]/4;

// obere Schnabelform
  #declare curve_5[i][0] = .5+(20-.5)*i/(num_points-1);
  #declare curve_5[i][1] = 10*pow(curve_5[i][0]+.75,-0.5)-curve_5[i][0]*curve_5[i][0]/64;

// untere Schnabelform
  #declare curve_6[i][0] = .5+(20-.5)*i/(num_points-1);
  #declare curve_6[i][1] = 10*pow(curve_6[i][0]+1,-0.5)+curve_6[i][0]*curve_6[i][0]/38;
  #declare curve_7[i][0] = .5+(20-.5)*i/(num_points-1);
  #declare curve_7[i][1] = curve_6[i][1]+2*pow(curve_6[i][0]+1,-0.8);

  #local i = i + 1;
#end

// unterer Schnabel
#declare tux_peek_u
= intersection 
{
  difference
  {
    prism 
    {
      cubic_spline 
      -8.2, 3, (num_points+4),
      < curve_4[num_points-1][0] , curve_4[num_points-1][1]-.1 > ,
      < 0 , 0 > ,
      #local i = 0;
      #while (i < num_points)
        < curve_4[i][0] , curve_4[i][1]-.1 >,
        #local i = i + 1;
      #end
      < 0 , 0 > ,
      < curve_4[1][0] , curve_4[1][1]-.1 >

      pigment { color rgb <1,1,0> }
    }
    lathe 
    {
      cubic_spline 
      (num_points+2),
      < 0 , -curve_7[0][1]-.5 >,
      #local i = 0;
      #while (i < num_points)
        < curve_7[i][0] , -curve_7[i][1] >,
        #local i = i + 1;
      #end
      < 0 , 0 >

      pigment { color rgb <1,1,0> }
    }
  }
  lathe 
  {
    cubic_spline 
    (num_points+2),
    < 0 , -curve_6[0][1] >,
    #local i = 0;
    #while (i < num_points)
      < curve_6[i][0] , -curve_6[i][1] >,
      #local i = i + 1;
    #end
    < 0 , 0 >

    pigment { color rgb <.5,.05,.05> }
  }
}

// oberer Schnabel
#declare tux_peek_o
= intersection
{
  difference 
  {
    prism 
    {
      cubic_spline
      -3, 8.5, (num_points+4),
      < curve_4[num_points-1][0] , curve_4[num_points-1][1] > ,
      < 0 , 0 > ,
      #local i = 0;
      #while (i < num_points)
        < curve_4[i][0] , curve_4[i][1] >,
        #local i = i + 1;
      #end
      < 0 , 0 > ,
      < curve_4[1][0] , curve_4[1][1] >

      pigment { color rgb <1,1,0> }
    }
    lathe
    {
      cubic_spline 
      (num_points+2),
      < 0 , curve_5[0][1]-.5 >,
      #local i = 0;
      #while (i < num_points)
        < curve_5[i][0] , curve_5[i][1]-.5 >,
        #local i = i + 1;
      #end
      < 0 , 0 >

      pigment { color rgb <.5,.05,.05> }
    }
  }
  lathe 
  { 
    cubic_spline 
    (num_points+2),
    < 0 , curve_5[0][1] >,
    #local i = 0;
    #while (i < num_points)
      < curve_5[i][0] , curve_5[i][1] >,
      #local i = i + 1;
    #end
    < 0 , 0 >

    pigment { color rgb <1,1,0> }
  }
}

// #############################################################################################
// Auge
#declare tux_eye
= sphere 
{
  < 0 , 0 , 0 > , 8 
}
#declare tux_eye_cap
= difference
{
  sphere { < 0 , 0 , 0 > , 8.2 }
  plane  { < 0 , 1 , 0 > , -1 }
}
// #############################################################################################

#declare eye_finish
= finish 
{
  specular 0.2
  roughness 0.01
  ambient .25
  diffuse .5
  reflection .1
  irid 
  {               // Iridescence (Newton's thin film interference)
    0.15               // intensity
    thickness 0.03    // film's thickness [0.0]
    turbulence 0.3   // film's thickness turbulence
  } 
}

// Auge
#declare tux_eye_rechts_scale       = <-1.5,2.0,0.4>;
#declare tux_eye_links_scale        = <+1.5,2.0,0.4>;
#declare tux_eye_rechts_sichtachse  = transform { rotate xyz_tux_eye_rechts_rotate rotate < -25+5 , +17.75-1 , +2-1 > }
#declare tux_eye_links_sichtachse   = transform { rotate xyz_tux_eye_links_rotate  rotate < -25+5 , +17.75-1 , +2-1 > }

#declare eye_cylinder_iris    = cylinder { < 0 , 0 , 9 > , < 0 , 0 , -9 > , 5.5 }
#declare eye_cylinder_pupille = cylinder { < 0 , 0 , 9 > , < 0 , 0 , -9 > , 4 }

#declare tux_eye_rechts
= union
{
  intersection
  {
    object { tux_eye }
    difference
    {
      object { eye_cylinder_iris    transform tux_eye_rechts_sichtachse }
      object { eye_cylinder_pupille transform tux_eye_rechts_sichtachse }
    }
    texture { pigment { color rgb <.05,.05,.5> } finish { eye_finish } }
  }
  difference
  {
    object { tux_eye }
    object { eye_cylinder_iris    transform tux_eye_rechts_sichtachse }
    texture { pigment { color rgb <.90,.91,.98> } finish { eye_finish } }
  }
  intersection
  {
    object { tux_eye }
    object { eye_cylinder_pupille transform tux_eye_rechts_sichtachse }
    texture { pigment { color rgb 0 } finish { metallic }  }
  }
  difference
  {
    object { tux_eye_cap rotate xyz_tux_eye_rechts_lied_rotate }
    object { tux_eye }
    texture { pigment { color rgb .005 } finish { metallic } }
  }
  scale tux_eye_rechts_scale
}

#declare tux_eye_links
= union
{
  intersection
  {
    object { tux_eye }
    difference
    {
      object { eye_cylinder_iris    transform tux_eye_links_sichtachse }
      object { eye_cylinder_pupille transform tux_eye_links_sichtachse }
    }
    texture { pigment { color rgb <.05,.05,.5> } finish { eye_finish } }
  }
  difference
  {
    object { tux_eye }
    object { eye_cylinder_iris    transform tux_eye_links_sichtachse }
    texture { pigment { color rgb <.90,.91,.98> } finish { eye_finish } }
  }
  intersection
  {
    object { tux_eye }
    object { eye_cylinder_pupille transform tux_eye_links_sichtachse }
    texture { pigment { color rgb 0 } finish { metallic }  }
  }
  difference
  {
    object { tux_eye_cap rotate xyz_tux_eye_links_lied_rotate }
    object { tux_eye }
    texture { pigment { color rgb .005 } finish { metallic } }
  }
  scale tux_eye_links_scale 
}

// Kopf
#declare tux_head 
= union
{
  sphere { < 0 , 0 , 0 > , 45 pigment { color rgb xyz_tux_body_light*<.015,.015,.03> } }
  object { tux_eye_rechts rotate < 2, 0, +.1 > translate <0,0,-45+2.6> rotate < 25 , +17.75 , 0 > } // rechtes Auge
  object { tux_eye_links  rotate < 2, 0, -.1 > translate <0,0,-45+2.6> rotate < 25 , -17.75 , 0 > } // linkes Auge
  object { tux_peek_o translate <0,-.5,1.45> scale <2.9,2.5,1.9> translate <0,-8.0,-44.7> rotate tux_peek_o_rot }
  object { tux_peek_u translate <0,0,2.> scale <2.8,2.5,1.9> translate <0,+6.5,-44.7> rotate tux_peek_u_rot }
  rotate xyz_tux_head_rotate
}

// Koerper
#declare tux_body 
= union
{
  blob 
  {
    threshold .75
    sphere { <0,110,0>,68 /*60*/, 1 }  //head
    sphere { <0,0,0>,170, 1 translate xyz_tux_body_trans }  //tail
    cylinder { xyz_tux_body_trans, <0,100,0> , 50 , 1 }  //heal
    pigment { color rgb xyz_tux_body_light*<.015,.015,.03> } 
  }
  sphere 
  {
    < 0 , 0 , 0 > , 60
    pigment { color rgb <.90,.91,.98> } 
    rotate < -15 , 0 , 0 > 
    scale < .85 , 1 , .92 > 
    rotate < -15 , 0 , 0 > 
    clipped_by { plane { < 0 , 0 , 1 > , 0 } } 
    translate < 0 , 2 , -10 > 
    translate xyz_tux_body_trans
  }
}

// linker Fuss 
#declare tux_foot 
= object
{
  intersection
  {
    lathe 
    { 
      cubic_spline (num_points+5),
      < 0 , 0 >
      < 0 , curve_3[0][1] >,
      #local i = 0;
      #while (i < num_points)
        < curve_3[i][0] , curve_3[i][1] >,
        #local i = i + 1;
      #end
      < curve_3[num_points-1][0]+curve_3[num_points-1][1]/2 , curve_3[num_points-1][1]/2 >,
      < curve_3[num_points-1][0]+curve_3[num_points-1][1] , 0 >,
      < 0 , 0 >
    }
    prism 
    { 
      cubic_spline -3, 12, (num_points*2+3),
      < curve_2[num_points-1][0] , curve_2[num_points-1][1] > ,
      #local i = 0;
      #while (i < num_points)
        < curve_1[i][0] , curve_1[i][1] >,
        #local i = i + 1;
      #end
      #local i = 0;
      #while (i < num_points)
        < curve_2[i][0] , curve_2[i][1] >,
        #local i = i + 1;
      #end
      < curve_1[0][0] , curve_1[0][1] >,
      < curve_1[1][0] , curve_1[1][1] >
    }
  }

  pigment { color rgb <1,1,0> }

  rotate <5,0,5>
}


#declare tux_feet
= union
{
  object { tux_foot scale <-3.5,3.5,3.5> rotate xyz_tux_foot_rechts_rotate translate <-32,-2,0> translate xyz_tux_foot_rechts_trans }
  object { tux_foot scale <+3.5,3.5,3.5> rotate xyz_tux_foot_links_rotate  translate <+32,-2,0> translate xyz_tux_foot_links_trans }
}

#declare tux_para_bag = union
{
 bicubic_patch 
 {
  type 0 u_steps 5 v_steps 5
  <-1.45,- 0.70,-1.65>, <-0.70, 0.00,-1.90>, < 0.70, 0.00,-1.90>, < 1.45,- 0.70,-1.65>,
  <-1.80,- 0.70,-1.00>, <-3.00,-1.20,-1.90>, < 3.00,-1.20,-1.90>, < 1.80,- 0.70,-1.00>,
  <-1.80,- 0.70, 1.00>, <-3.00,-1.20, 3.25>, < 3.00,-1.20, 3.25>, < 1.80,- 0.70, 1.00>,
  <-1.45,- 0.70, 1.65>, <-0.80, 0.00, 2.00>, < 0.80, 0.00, 2.00>, < 1.45,- 0.70, 1.65>
  pigment { color rgb <.75,.1,.1> }
 }

 bicubic_patch 
 {
  type 0 u_steps 5 v_steps 5
  <-1.45,- 0.70,-1.65>, <-0.70, 0.00,-1.90>, < 0.70, 0.00,-1.90>, < 1.45,- 0.70,-1.65>,
  <-1.80,- 0.70,-1.00>, <-3.00, 2.00,-2.90>, < 3.00, 2.00,-2.90>, < 1.80,- 0.70,-1.00>,
  <-1.80,- 0.70, 1.00>, <-3.00, 3.40,-1.00>, < 3.00, 3.40,-1.00>, < 1.80,- 0.70, 1.00>,
  <-1.60,-0.80, 1.20>, <-1.90, 2.20, 0.30>, < 1.90, 2.20, 0.30>, < 1.60,-0.80, 1.20>
  pigment { color rgb <.1,.75,.1> }
 }
 
 bicubic_patch 
 {
  type 0 u_steps 5 v_steps 5
  <-1.60,-0.80, 1.20>, <-1.90, 2.20, 0.30>, < 1.90, 2.20, 0.30>, < 1.60,-0.80, 1.20>,
  <-1.55,- 0.70, 1.35>, <-1.25, 3.05, 2.45>, < 1.25, 3.05, 2.45>, < 1.55,- 0.70, 1.35>,
  <-1.55,- 0.70, 1.45>, <-1.25, 1.25, 2.15>, < 1.25, 1.25, 2.15>, < 1.55,- 0.70, 1.45>,
  <-1.45,- 0.70, 1.65>, <-0.80, 0.00, 2.00>, < 0.80, 0.00, 2.00>, < 1.45,- 0.70, 1.65>
  pigment { color rgb <.1,.1,.75> }
 }
}

#declare curve_fp = array[16]
{
   <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>,
   <-45.00, 10.00,-10.00>, <-15.00, 15.60, 10.00>, < 15.00, 15.60, 10.00>, < 45.00, 10.00,-10.00>,
   <-30.00, 10.00, 70.00>, <-15.00, 12.30, 50.00>, < 15.00, 12.30, 50.00>, < 30.00, 10.00, 70.00>,
   <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>
}
#declare curve_fm = array[16]
{
   <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>, <  0.00,  0.00,-10.00>,
   <-45.00, 10.00,-10.00>, <-15.00,-12.60, 10.00>, < 15.00,-12.60, 10.00>, < 45.00, 10.00,-10.00>,
   <-30.00, 10.00, 70.00>, <-15.00,-11.30, 50.00>, < 15.00,-11.30, 50.00>, < 30.00, 10.00, 70.00>,
   <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>, <  0.00,  0.00, 70.00>
}

#local dreh_r = 85;
#local tux_flosse = 
union
{
 bicubic_patch 
 {
  type 0 u_steps 5 v_steps 5 
  #local i=0;
  #while (i<16)
      vaxis_rotate(<curve_fm[i].x,curve_fp[i].y+dreh_r,0>,<1,0,0>,180*curve_fp[i].z/pi/(dreh_r+curve_fp[i].y))
        -<0,dreh_r,0>
	+(curve_fp[i].z>20 ? tux_flug*<
	curve_fp[i].x*curve_fp[i].x/tux_flug_x,
	curve_fp[i].z*curve_fp[i].z/tux_flug_z+curve_fp[i].y*curve_fp[i].y/tux_flug_y,
	0
	> : <0,0,0>)
    #local i=i+1;
  #end
  rotate <90,-90,0>
 }

 bicubic_patch 
 { 
  type 0 u_steps 5 v_steps 5
  #local i=0;
  #while (i<16)
      vaxis_rotate(
        <curve_fm[i].x,curve_fm[i].y+dreh_r,0>,
        <1,0,0>,180*curve_fm[i].z/pi/(dreh_r+curve_fm[i].y)
        )
        -<0,dreh_r,0>
	+(curve_fm[i].z>20 ? tux_flug*<
	curve_fm[i].x*curve_fm[i].x/tux_flug_x,
	curve_fm[i].z*curve_fm[i].z/tux_flug_z+curve_fm[i].y*curve_fm[i].y/tux_flug_y,
	0
	> : <0,0,0>)
    #local i=i+1;
  #end
  rotate <90,-90,0>
 } 
 pigment { color rgb xyz_tux_body_light*<.018,.018,.035> } 
}

#declare tux
= union
{
  object { tux_head translate <0,170,-5> }
  object { tux_body translate <0,73,0> }
  object { tux_feet translate <0,0,0> }
  object { tux_flosse scale <+1,1,1> rotate <20,-10,-20> translate <-53*cos(pi*10/180),99,-53*sin(pi*10/180)> translate xyz_tux_body_trans }
  object { tux_flosse scale <-1,1,1> rotate <20,+10,+20> translate <+53*cos(pi*10/180),99,-53*sin(pi*10/180)> translate xyz_tux_body_trans }
  object { tux_para_bag rotate <90,0,0> scale <25,20,10> translate <0,73,55> translate xyz_tux_body_trans }
  rotate xyz_tux_rotate
  translate xyz_tux_trans
}

#end